Index: data/Media/materials/scripts/Bloom.material
===================================================================
--- data/Media/materials/scripts/Bloom.material	(revision 5125)
+++ data/Media/materials/scripts/Bloom.material	(revision 5126)
@@ -160,5 +160,5 @@
         {
             lighting on
-            diffuse 0.0 0.0 0.0 0.6
+            diffuse 0.0 0.0 0.0 0.8
             specular 0.0 0.0 0.0 0.0
             ambient 0.0 0.0 0.0
Index: data/Media/materials/scripts/Bump_Specular.material
===================================================================
--- data/Media/materials/scripts/Bump_Specular.material	(revision 5125)
+++ data/Media/materials/scripts/Bump_Specular.material	(revision 5126)
@@ -4,45 +4,8 @@
 //--------------
 
-// Bump map vertex program, support for this is required
-vertex_program BumpMap2VP cg
-{
-	source BumpMapping.cg
-	entry_point main_vp
-	profiles vs_1_1 arbvp1
-}
-
-// Bump map fragment program, support for this is optional
-fragment_program BumpMap2FP cg
-{
-	source BumpMapping.cg
-	entry_point main_fp
-	profiles ps_1_1 arbfp1 fp20
-}
-
-// Bump map with specular vertex program, support for this is required
-vertex_program BumpMap2VPSpecular cg
-{
-	source BumpMapping.cg
-	entry_point specular_vp
-	profiles vs_1_1 arbvp1
-}
-
-// Bump map fragment program, support for this is optional
-fragment_program BumpMap2FPSpecular cg
-{
-	source BumpMapping.cg
-	entry_point specular_fp
-	profiles ps_1_1 arbfp1 fp20
-
-	default_params
-	{
-        param_named shine float 3
-	}
-
-}
 
 
 // Any number of lights, diffuse and specular
-material BumpMapping/MultiLightSpecular
+material Assff/BumpMap
 {
 
@@ -84,5 +47,5 @@
 
 			// Vertex program reference
-			vertex_program_ref BumpMap2VPSpecular
+			vertex_program_ref BumpMapVPSpecular
 			{
 				param_named_auto lightPosition light_position_object_space 0
@@ -92,9 +55,9 @@
 
 			// Fragment program
-			fragment_program_ref BumpMap2FPSpecular
+			fragment_program_ref BumpMapFPSpecular
 			{
 				param_named_auto lightDiffuse light_diffuse_colour 0
 				param_named_auto lightSpecular light_specular_colour 0
-                param_named shine float 20
+                                param_named shine float 2
 			}
 
@@ -102,5 +65,5 @@
 			texture_unit
 			{
-				texture NMnone.tga
+				texture nmnone.tga
 				colour_op replace
 			}
@@ -137,5 +100,5 @@
 			texture_unit
 			{
-				texture assff.jpg
+				texture assff.JPG
 			}
 
@@ -181,5 +144,5 @@
 
 			// Vertex program reference
-			vertex_program_ref BumpMap2VP
+			vertex_program_ref BumpMapVP
 			{
 				param_named_auto lightPosition light_position_object_space 0
@@ -190,5 +153,5 @@
 			texture_unit
 			{
-				texture NMnone.tga
+				texture nmnone.tga
 				colour_op replace
 			}
@@ -220,5 +183,5 @@
 			texture_unit
 			{
-				texture assff.jpg
+				texture assff.JPG
 			}
 
Index: data/Media/materials/scripts/MotionBlur.material
===================================================================
--- data/Media/materials/scripts/MotionBlur.material	(revision 5125)
+++ data/Media/materials/scripts/MotionBlur.material	(revision 5126)
@@ -7,5 +7,5 @@
 	default_params
 	{
-		param_named blur float 0.6
+		param_named blur float 0.7
 	}
 }
Index: data/Media/materials/scripts/asteroids.material
===================================================================
--- data/Media/materials/scripts/asteroids.material	(revision 5125)
+++ data/Media/materials/scripts/asteroids.material	(revision 5126)
@@ -66,5 +66,5 @@
 			{
 				param_named_auto worldViewProj worldviewproj_matrix
-				param_named_auto ambient ambient_light_colour
+				param_named ambient float3 0.1 0.1 0.1
 			}
 
@@ -96,4 +96,5 @@
 				param_named_auto lightDiffuse light_diffuse_colour 0
 				param_named_auto lightSpecular light_specular_colour 0
+                                param_named shine float 4
 			}
 
@@ -101,5 +102,5 @@
 			texture_unit
 			{
-				texture NMrock.tga
+				texture nmrock.tga
 				colour_op replace
 			}
@@ -189,5 +190,5 @@
 			texture_unit
 			{
-				texture NMrock.tga
+				texture nmrock.tga
 				colour_op replace
 			}